using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using System.Data;
using Syncfusion.Windows.Forms.Grid;
using Syncfusion.Windows.Forms.Grid.Grouping;
using Syncfusion.Grouping;
using Syncfusion.Diagnostics;

namespace GGC_HideTable
{
	/// <summary>
	/// Summary description for Form1.
	/// </summary>
	public class Form1 : System.Windows.Forms.Form
	{
		private Syncfusion.Windows.Forms.Grid.Grouping.GridGroupingControl gridGroupingControl1;
		/// <summary>
		/// Required designer variable.
		/// </summary>
		private System.ComponentModel.Container components = null;

		public Form1()
		{
			//
			// Required for Windows Form Designer support
			//
			
			InitializeComponent();

			//
			// TODO: Add any constructor code after InitializeComponent call
			//
		}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if (components != null) 
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			this.gridGroupingControl1 = new Syncfusion.Windows.Forms.Grid.Grouping.GridGroupingControl();
			((System.ComponentModel.ISupportInitialize)(this.gridGroupingControl1)).BeginInit();
			this.SuspendLayout();
			// 
			// gridGroupingControl1
			// 
			this.gridGroupingControl1.Anchor = ((System.Windows.Forms.AnchorStyles)((((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Bottom) 
				| System.Windows.Forms.AnchorStyles.Left) 
				| System.Windows.Forms.AnchorStyles.Right)));
			this.gridGroupingControl1.BackColor = System.Drawing.SystemColors.Window;
			this.gridGroupingControl1.Location = new System.Drawing.Point(16, 24);
			this.gridGroupingControl1.Name = "gridGroupingControl1";
			this.gridGroupingControl1.ShowGroupDropArea = true;
			this.gridGroupingControl1.Size = new System.Drawing.Size(576, 424);
			this.gridGroupingControl1.TabIndex = 0;
			this.gridGroupingControl1.TableDescriptor.AllowNew = false;
			this.gridGroupingControl1.Text = "gridGroupingControl1";
			this.gridGroupingControl1.VersionInfo = "4.101.0.22";
			
			
			
			// 
			// Form1
			// 
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
			this.ClientSize = new System.Drawing.Size(608, 486);
			this.Controls.Add(this.gridGroupingControl1);
			this.Name = "Form1";
			this.Text = "Form1";
			this.Load += new System.EventHandler(this.Form1_Load);
			((System.ComponentModel.ISupportInitialize)(this.gridGroupingControl1)).EndInit();
			this.ResumeLayout(false);

		}
		#endregion

		/// <summary>
		/// The main entry point for the application.
		/// </summary>
		[STAThread]
		static void Main() 
		{
			Application.Run(new Form1());
		}
		private int numberParentRows = 20;
		private int numberChildRows = 10;

		private DataTable GetParentTable()
		{
			DataTable dt = new DataTable("ParentTable");

			
			dt.Columns.Add(new DataColumn("parentID",typeof(int))); //lower case p
			dt.Columns.Add(new DataColumn("ParentName",typeof(int)));
			dt.Columns.Add(new DataColumn("ParentDec",typeof(int)));
			dt.Columns.Add(new DataColumn("check", typeof(string)));

			for(int i = 0; i < numberParentRows; ++i)
			{
				DataRow dr = dt.NewRow();
				dr[0] = i + 1;//.ToString();
				dr[1] = i%5 + 1;
				dr[2] = (i +1) *12;
				dt.Rows.Add(dr);
			}

			return dt;
		}

		private DataTable GetChildTable()
		{
			DataTable dt = new DataTable("ChildTable");

			dt.Columns.Add(new DataColumn("childID")); //lower case c
			dt.Columns.Add(new DataColumn("Name"));
			dt.Columns.Add(new DataColumn("ParentID")); //upper case P
			
			for(int i = 0; i < numberChildRows; ++i)
			{
				DataRow dr = dt.NewRow();
				dr[0] = i.ToString();
				dr[1] = string.Format("ChildName{0}",i);
				dr[2] = (i % numberParentRows).ToString();
				dt.Rows.Add(dr);
			}		
			return dt;
		}
		
		private void Form1_Load(object sender, System.EventArgs e)
		{
			DataTable parentTable = GetParentTable();
			this.gridGroupingControl1.TopLevelGroupOptions.ShowSummaries = true;
			this.gridGroupingControl1.NestedTableGroupOptions.ShowSummaries = true;
			this.gridGroupingControl1.ChildGroupOptions.ShowSummaries = true;

			this.gridGroupingControl1.DataSource = parentTable;			

			#region Adding the SummaryCell 

			GridSummaryColumnDescriptor sd1 = new GridSummaryColumnDescriptor("ParentDec",SummaryType.Int32Aggregate ,"ParentDec","{Sum:####}"); 
			GridSummaryColumnDescriptor sd2 = new GridSummaryColumnDescriptor("ParentName",SummaryType.Int32Aggregate ,"ParentName","{Sum:####}"); 
			//For showing two summary row
			this.gridGroupingControl1.TableDescriptor.SummaryRows.Add( new GridSummaryRowDescriptor("CaptionSummaryRow", "Summary1", new GridSummaryColumnDescriptor[] {sd1}));
			this.gridGroupingControl1.TableDescriptor.Appearance.AnySummaryCell.Borders.All = new GridBorder(GridBorderStyle.Standard);        
			this.gridGroupingControl1.TableDescriptor.Appearance.AnySummaryCell.BackColor = Color.AliceBlue; 

			#endregion
			
			this.gridGroupingControl1.TableDescriptor.GroupedColumns.Add("ParentName");    
			this.gridGroupingControl1.QueryCellStyleInfo += new GridTableCellStyleInfoEventHandler(gridGroupingControl1_QueryCellStyleInfo);			
			this.gridGroupingControl1.GroupExpanded += new GroupEventHandler(gridGroupingControl1_GroupExpanded);
			this.gridGroupingControl1.GroupCollapsed += new GroupEventHandler(gridGroupingControl1_GroupCollapsed);
		}

		private void gridGroupingControl1_QueryCellStyleInfo(object sender, GridTableCellStyleInfoEventArgs e)
		{
			if(e.TableCellIdentity.TableCellType == GridTableCellType.GroupCaptionCell)
			{
				e.Style.CellType = "Static";
				e.Style.Clickable = true;
				e.Style.Enabled = true;
			}
		}
		
		private void gridGroupingControl1_GroupExpanded(object sender, GroupEventArgs e)
		{			
				SendKeys.Send("{Tab}"); 
		}

		private void gridGroupingControl1_GroupCollapsed(object sender, GroupEventArgs e)
		{
				SendKeys.Send("{Tab}"); 
		}
	}
}
